/*
 *  Copyright (C) 2005 Mohamed Louizi
 *  Copyright (C) 2006,2007 Christoph Sommer <christoph.sommer@informatik.uni-erlangen.de>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef APPLICATIONS_DTRB_DTRB_ROUTEBLOCK_H
#define APPLICATIONS_DTRB_DTRB_ROUTEBLOCK_H

#include <stdexcept>

namespace DTRB{

class DTRB_RouteBlock
{
	protected:
		double ctrlMsgTime;
		double distTime;
		double qValue;
		uint32_t node;
		//uint8_t prefix;

	public:

		DTRB_RouteBlock() : ctrlMsgTime(0), distTime(0), qValue(0), node(0)
		{
		}

		DTRB_RouteBlock(const DTRB_RouteBlock& other)
		{
			operator=(other);
		}

		DTRB_RouteBlock& operator=(const DTRB_RouteBlock& other)
		{
			if (this==&other) return *this;
			this->ctrlMsgTime = other.ctrlMsgTime;
			this->distTime = other.distTime;
			this->qValue = other.qValue;
			this->node = other.node;
			return *this;
		}


		double getCtrlMsgTime() const
			{
				//if (!hasRoute()) throw std::runtime_error("Tried to read Route from RouteBlock, but found none");
				return ctrlMsgTime;
			}

		double getDist() const
			{
				//if (!hasRoute()) throw std::runtime_error("Tried to read Route from RouteBlock, but found none");
				return distTime;
			}
		double getQvalue() const
				{
					//if (!hasRoute()) throw std::runtime_error("Tried to read Route from RouteBlock, but found none");
					return qValue;
				}
		uint32_t getNode() const
			{
				//if (!hasRoute()) throw std::runtime_error("Tried to read Route from RouteBlock, but found none");
				return node;
			}

		void setCtrlMsgTime(double ctrlMsgTime)
			{
				this->ctrlMsgTime = ctrlMsgTime;
			}

		void setDist(double distTime)
			{
				this->distTime = distTime;
			}

		void setQvalue(double qValue)
			{
				this->qValue = qValue;
			}

		void setNode(uint32_t node)
			{
				this->node = node;
			}
/*
		uint8_t getPrefix() const
			{
				return prefix;
			}

			void setPrefix(uint8_t prefix)
			{
				this->prefix = prefix;
			}
*/

};
}

typedef DTRB::DTRB_RouteBlock DTRBnet_DTRB_RouteBlock;

#endif

